From dfb728a2ea4d4e9e1e3e3bf433b0f0d6a0a195d8 Mon Sep 17 00:00:00 2001
From: Daniel Mierswa <impulze@impulze.org>
Date: Sat, 30 Jan 2010 22:13:45 +0100
Subject: [PATCH 07/10] Integrate pkg-config handling to vlc_features.m4.


Signed-off-by: Daniel Mierswa <impulze@impulze.org>
---
 configure.ac       |   71 +++++++++++++++++++++------------------
 m4/vlc_features.m4 |   71 ++++++++++++++++++++++++++++++++++++++++
 m4/with_pkg.m4     |   92 ----------------------------------------------------
 3 files changed, 109 insertions(+), 125 deletions(-)
 delete mode 100644 m4/with_pkg.m4

diff --git a/configure.ac b/configure.ac
index e3e89a9..692a3fa 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1259,7 +1259,7 @@ AS_IF([VLC_FEATURE_ENABLED([growl])], [
 dnl
 dnl Libnotify notification plugin
 dnl
-PKG_ENABLE_MODULES_VLC([NOTIFY], [], [libnotify], [libnotify notification], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([notify], [libnotify], [libnotify notification])
 
 dnl
 dnl Audioscrobbler plugin
@@ -1408,8 +1408,8 @@ dnl
 dnl - special access module for dc1394 input
 dnl - dv module: digital video module check for libraw1394
 dnl
-PKG_ENABLE_MODULES_VLC([DC1394], [], [libraw1394 >= 2.0.1 libdc1394-2 >= 2.1.0], [dc1394 access module], [auto])
-PKG_ENABLE_MODULES_VLC([DV], [access_dv], [libraw1394 >= 2.0.1 libavc1394 >= 0.5.3], [DV input module], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([dc1394], [libraw1394 >= 2.0.1 libdc1394-2 >= 2.1.0], [dc1394 access module])
+VLC_PKGCONFIG_FEATURE_MOD([dv], [libraw1394 >= 2.0.1 libavc >= 0.5.3], [DV input module], [access_dv])
 
 dnl
 dnl dvdread module: check for libdvdread
@@ -1781,7 +1781,7 @@ AS_IF([VLC_FEATURE_ENABLED([pvr])], [
 dnl
 dnl  gnomeVFS access module
 dnl
-PKG_ENABLE_MODULES_VLC([GNOMEVFS], [access_gnomevfs], [gnome-vfs-2.0], [GnomeVFS access module], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([gnomevfs], [gnome-vfs-2.0], [GnomeVFS access module], [access_gnomevfs])
 
 dnl
 dnl  VCDX modules
@@ -1916,14 +1916,16 @@ AC_CHECK_FUNCS(inet_ntop,[
 dnl
 dnl  ogg demux plugin
 dnl
-PKG_ENABLE_MODULES_VLC([OGG], [], [ogg >= 1.0], [Ogg demux support], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([ogg], [ogg >= 1.0], [Ogg demux support])
 AS_IF([VLC_FEATURE_ENABLED([sout])], [
-    PKG_ENABLE_MODULES_VLC([MUX_OGG], [], [ogg >= 1.0], [Ogg demux support], [auto])
+  VLC_PKGCONFIG_FEATURE_MOD([mux_ogg], [ogg >= 1.0], [Ogg demux support])
 ])
 
-AS_IF([VLC_FEATURE_ENABLED([sout])], [
+dnl
 dnl Check for libshout
-PKG_ENABLE_MODULES_VLC([SHOUT], [access_output_shout], [shout >= 2.1], [libshout output plugin], [auto])
+dnl
+AS_IF([VLC_FEATURE_ENABLED([sout])], [
+  VLC_PKGCONFIG_FEATURE_MOD([shout], [shout >= 2.1], [libshout output plugin], [access_output_shout])
 ])
 
 dnl
@@ -2367,7 +2369,10 @@ AS_IF([VLC_FEATURE_ENABLED([faad])], [
 dnl
 dnl twolame encoder plugin
 dnl
-PKG_ENABLE_MODULES_VLC([TWOLAME], [], [twolame], [MPEG Audio Layer 2 encoder], [auto], [], [], [ -DLIBTWOLAME_STATIC])
+VLC_PKGCONFIG_FEATURE_MOD([twolame], [twolame], [MPEG Audio Layer 2 encoder])
+AS_IF([test "x${have_twolame}" = "xyes"], [
+  VLC_ADD_CPPFLAGS([twolame], [-DLIBTWOLAME_STATIC])
+])
 
 dnl
 dnl  QuickTime plugin
@@ -2487,22 +2492,22 @@ AS_IF([VLC_FEATURE_ENABLED([a52-fixed])], [
 dnl
 dnl DTS Coherent Acoustics decoder plugin
 dnl
-PKG_ENABLE_MODULES_VLC([DCA], [dtstofloat32], [libdca >= 0.0.5], [DTS Coherent Acoustics support with libdca], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([dca], [libdca >= 0.0.5], [DTS Coherent Acoustics support with libdca], [dtstofloat32])
 
 dnl
 dnl  Flac plugin
 dnl
-PKG_ENABLE_MODULES_VLC([FLAC], [], [flac], [libflac decoder/encoder support], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([flac], [flac], [libflac decoder/encoder support])
 
 dnl
 dnl  Libmpeg2 plugin
 dnl
-PKG_ENABLE_MODULES_VLC([LIBMPEG2], [], [libmpeg2 > 0.3.2], [libmpeg2 decoder support], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([libmpeg2], [libmpeg2 > 0.3.], [libmpeg2 decoder support])
 
 dnl
 dnl  Vorbis plugin
 dnl
-PKG_ENABLE_MODULES_VLC([VORBIS], [], [ogg vorbis >= 1.1 vorbisenc >= 1.1], [Vorbis decoder and encoder], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([vorbis], [ogg vorbis >= 1.1 vorbisenc >= 1.1], [Vorbis decoder and encoder])
 
 dnl
 dnl  Tremor plugin
@@ -2518,22 +2523,22 @@ AS_IF([VLC_FEATURE_ENABLED([tremor])], [
 dnl
 dnl  Speex plugin
 dnl
-PKG_ENABLE_MODULES_VLC([SPEEX], [], [ogg speex >= 1.0.5], [Speex decoder support], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([speex], [ogg speex >= 1.0.5], [Speex decoder support])
 
 dnl
 dnl  theora decoder plugin
 dnl
-PKG_ENABLE_MODULES_VLC([THEORA], [], [ogg theora >= 1.0], [experimental theora codec], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([theora], [ogg theora >= 1.0], [experimental theora codec])
 
 dnl
 dnl  dirac encoder plugin
 dnl
-PKG_ENABLE_MODULES_VLC([DIRAC], [], [dirac >= 0.10.0], [dirac encoder], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([dirac], [dirac >= 0.10.0], [dirac encoder])
 
 dnl
 dnl  schroedinger decoder plugin (for dirac format video)
 dnl
-PKG_ENABLE_MODULES_VLC([SCHROEDINGER], [], [schroedinger-1.0 >= 1.0.6], [dirac decoder using schroedinger], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([schroedinger], [schroedinger-1.0 >= 1.0.6], [dirac decoder using schroedinger])
 
 dnl
 dnl  PNG decoder module
@@ -2616,7 +2621,7 @@ AS_IF([VLC_FEATURE_ENABLED([x264])], [
 dnl
 dnl libfluidsynth (MIDI synthetizer) plugin
 dnl
-PKG_ENABLE_MODULES_VLC([FLUIDSYNTH], [], [fluidsynth], [MIDI synthetiser with libfluidsynth], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([fluidsynth], [fluidsynth], [MIDI synthetiser with libfluidsynth])
 
 dnl
 dnl Teletext Modules
@@ -2937,12 +2942,12 @@ from http://www.freetype.org/, or configure with --disable-freetype. Have a nice
 dnl
 dnl  libxml2 module
 dnl
-PKG_ENABLE_MODULES_VLC([LIBXML2], [xml], [libxml-2.0 >= 2.5], [libxml2 support],[auto])
+VLC_PKGCONFIG_FEATURE_MOD([libxml2], [libxml-2.0 >= 2.5], [libxml2 support], [xml])
 
 dnl
 dnl  SVG module
 dnl
-PKG_ENABLE_MODULES_VLC([SVG], [], [librsvg-2.0 >= 2.9.0], [SVG rendering library],[auto])
+VLC_PKGCONFIG_FEATURE_MOD([svg], [librsvg-2.0 >= 2.9.0], [SVG rendering library])
 
 dnl
 dnl Snapshot vout module (with cache)
@@ -3166,7 +3171,7 @@ AS_IF([VLC_FEATURE_ENABLED([aa])], [
 dnl
 dnl  libcaca plugin
 dnl
-PKG_ENABLE_MODULES_VLC([CACA], [], [caca >= 0.99.beta14], [libcaca output],[auto])
+VLC_PKGCONFIG_FEATURE_MOD([caca], [caca >= 0.99.beta14], [libcaca output])
 
 dnl
 dnl  Audio plugins
@@ -3193,17 +3198,17 @@ AS_IF([VLC_FEATURE_ENABLED([oss])], [
 dnl
 dnl  Pulseaudio module
 dnl
-PKG_ENABLE_MODULES_VLC([PULSE], [], [libpulse >= 0.9.11], [Pulseaudio support], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([pulse], [libpulse >= 0.9.11], [Pulseaudio support])
 
 dnl
 dnl  Portaudio module
 dnl
-PKG_ENABLE_MODULES_VLC([PORTAUDIO], [], [portaudio-2.0], [Portaudio library support], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([portaudio], [portaudio-2.0], [Portaudio library support])
 
 dnl
 dnl  ALSA module
 dnl
-PKG_ENABLE_MODULES_VLC([ALSA], [alsa access_alsa], [alsa >= 1.0.0], [Alsa sound support for linux], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([alsa], [alsa >= 1.0.0], [Alsa sound support for linux], [alsa access_alsa])
 
 dnl
 dnl  win32 waveOut plugin
@@ -3255,7 +3260,7 @@ AS_IF([VLC_FEATURE_ENABLED([hd1000a]) && test "${CXX}" != ""], [
 dnl
 dnl  JACK modules
 dnl
-PKG_ENABLE_MODULES_VLC([JACK], [jack access_jack], [jack], [JACK audio I/O modules],[auto])
+VLC_PKGCONFIG_FEATURE_MOD([jack], [jack], [JACK audio I/O modules], [jack access_jack])
 
 
 dnl
@@ -3334,7 +3339,7 @@ class testclass : public SearchResponseListener, public MediaPlayer
 dnl
 dnl UPnP Plugin (Intel SDK)
 dnl
-PKG_ENABLE_MODULES_VLC([UPNP], [upnp_intel], [libupnp], [Intel UPnp SDK],[auto])
+VLC_PKGCONFIG_FEATURE_MOD([upnp], [libupnp], [Intel UPnp SDK], [upnp_intel])
 
 
 dnl
@@ -3590,12 +3595,12 @@ AS_IF([VLC_FEATURE_ENABLED([visual])], [
 dnl
 dnl  goom visualization plugin
 dnl
-PKG_ENABLE_MODULES_VLC([GOOM], [], [libgoom2], [goom visualization plugin], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([goom], [libgoom2], [goom visualization plugin])
 
 dnl
 dnl libprojectM visualization plugin
 dnl
-PKG_ENABLE_MODULES_VLC([PROJECTM], [], [libprojectM], [projectM visualization plugin], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([projectm], [libprojectM], [projectM visualization plugin])
 
 dnl
 dnl  AtmoLight (homemade Philips Ambilight clone)
@@ -3611,15 +3616,15 @@ AS_IF([VLC_FEATURE_ENABLED([atmo])], [
 
 dnl
 dnl  Bonjour services discovery
-PKG_ENABLE_MODULES_VLC([BONJOUR], [], [avahi-client >= 0.6], [Bonjour services discovery], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([bonjour], [avahi-client >= 0.6], [Bonjour services discovery])
 
 dnl
 dnl  libudev services discovery
-PKG_ENABLE_MODULES_VLC([UDEV], [], [libudev >= 142], [Linux udev services discovery], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([udev], [libudev >= 142], [Linux udev services discovery])
 
 dnl
 dnl MTP devices services discovery
-PKG_ENABLE_MODULES_VLC([MTP], [], [libmtp >= 0.3.0],[MTP devices support],[auto])
+VLC_PKGCONFIG_FEATURE_MOD([mtp], [libmtp >= 0.3.0], [MTP devices support])
 
 dnl
 dnl  Lirc plugin
@@ -3732,7 +3737,7 @@ AS_IF([test "${have_libgcrypt}" = "yes"], [
 dnl
 dnl OSSO (Maemo screen blanking) plugin
 dnl
-PKG_ENABLE_MODULES_VLC([OSSO], [], [libosso], [Maemo support], [auto])
+VLC_PKGCONFIG_FEATURE_MOD([osso], [libosso], [Maemo support])
 
 AS_IF([test -f "/etc/maemo_version"], [
   AC_DEFINE([HAVE_MAEMO], 1, [Define to 1 if building for the Maemo platform.])
@@ -3759,7 +3764,7 @@ dnl
 VLC_FEATURE_OPTION([sqlite], [sqlite support])
 VLC_STRING_OPTION([sqlite], [sqlite path linking], [PATH])
 if test "${SYS}" != "darwin"; then
-  PKG_ENABLE_MODULES_VLC([SQLITE], [], [sqlite3 >= 3.6.0], [sqlite3], [auto])
+  VLC_PKGCONFIG_FEATURE_MOD([sqlite], [sqlite3 >= 3.6.0], [sqlite3])
 else
   AS_IF([VLC_FEATURE_ENABLED([sqlite])], [
     AC_CHECK_HEADERS(sqlite3.h, [
diff --git a/m4/vlc_features.m4 b/m4/vlc_features.m4
index ae11445..cf00100 100644
--- a/m4/vlc_features.m4
+++ b/m4/vlc_features.m4
@@ -1,6 +1,11 @@
 dnl Handling features and arguments to ./configure.
 dnl
 dnl Copyright © 2010 Daniel Mierswa <impulze@impulze.org>
+dnl 
+dnl pkg-config foo is based on previous with_pkg.m4 which is:
+dnl Copyright © 2008 Luca Barbato <lu_zero@gentoo.org>,
+dnl                  Diego Pettenò <flameeyes@gentoo.org>
+dnl                  Jean-Baptiste Kempf
 dnl
 dnl This program is free software; you can redistribute it and/or modify
 dnl it under the terms of the GNU General Public License as published by
@@ -32,6 +37,11 @@ dnl Create the same string autoconf uses for AC_ARG_ENABLE().
 AC_DEFUN([_VLC_FEATURE_STRING],
   [patsubst([$1], -, _)])
 
+dnl _VLC_PKGCONFIG_PREFIX(ENABLE-STRING)
+dnl Create pkg-config prefix name.
+AC_DEFUN([_VLC_PKGCONFIG_PREFIX],
+  [m4_bpatsubst([m4_toupper([$1])], [- ], _)])
+
 dnl _VLC_FEATURE_CHECK_VARIABLE(ENABLE-STRING, PREFIX, TEST)
 dnl Check if shell variable with prefix_ENABLE-STRING succeeds TEST.
 AC_DEFUN([_VLC_FEATURE_CHECK_VARIABLE], 
@@ -298,3 +308,64 @@ AC_DEFUN([VLC_STRING_OPTION], [
   m4_popdef([var])
   m4_popdef([default_string])
 ])
+
+dnl VLC_PKGCONFIG(ENABLE-STRING, MODULES, [ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND])
+dnl
+dnl Wrap around pkg-config searching for MODULES.
+dnl The pkg-config prefix is the uppercase ENABLE-STRING with '-' and ' ' replaced
+dnl by '_'.
+dnl If pkg-config finds something, have_ENABLE-STRING is set to yes, otherwise no.
+AC_DEFUN([VLC_PKGCONFIG], [
+  AC_REQUIRE([PKG_PROG_PKG_CONFIG])
+  m4_pushdef([prefix], _VLC_PKGCONFIG_PREFIX([$1]))
+
+  probed_modules="$2"
+
+  PKG_CHECK_MODULES(prefix, [$2], [
+    [have_]_VLC_FEATURE_STRING([$1])[="yes"]
+    $3
+  ], [
+    [have_]_VLC_FEATURE_STRING([$1])[="no"]
+    $4
+  ])
+
+  m4_popdef([prefix])
+])
+
+dnl VLC_FEATURE_CHECK(ENABLE-STRING, MESSAGE)
+dnl
+dnl If the package wasn't found but explicitly requested, error out.
+dnl If the package wasn't found but default enabled, warn.
+AC_DEFUN([VLC_FEATURE_CHECK], [
+  AS_IF([_VLC_FEATURE_CHECK_VARIABLE([$1], [have], [!= "xyes"])], [
+    AS_IF([VLC_FEATURE_REQUESTED([$1])], [AC_MSG_ERROR([$2])])
+    AS_IF([VLC_FEATURE_DEFAULT_ENABLED([$1])], [AC_MSG_WARN([$2])])
+  ])
+])
+
+dnl VLC_PKGCONFIG_FEATURE_MOD(ENABLE-STRING, MODULES, DESCRIPTION, [VLC-MODULES],
+dnl                           [DEFAULT-STRING])
+dnl
+dnl Add a VLC feature that is detected by using pkg-config.
+dnl If found add vlc plugins and additional *flags to it.
+dnl Wraps around VLC_FEATURE_OPTION, VLC_PKGCONFIG and VLC_FEATURE_CHECK.
+dnl If VLC-MODULES is blank it defaults to ENABLE-STRING.
+AC_DEFUN([VLC_PKGCONFIG_FEATURE_MOD], [
+  m4_pushdef([prefix], _VLC_PKGCONFIG_PREFIX([$1]))
+  m4_pushdef([module_name], m4_default([$4], [$1]))
+
+  VLC_FEATURE_OPTION([$1], [$3], [$5])
+
+  AS_IF([VLC_FEATURE_ENABLED([$1])], [
+    VLC_PKGCONFIG([$1], [$2], [
+      VLC_ADD_PLUGIN(module_name)
+      VLC_ADD_CFLAGS(module_name, [$]prefix[_CFLAGS])
+      VLC_ADD_LIBS(module_name, [$]prefix[_LIBS])
+    ], [
+      VLC_FEATURE_CHECK([$1], [${probed_modules} not found by pkg-config])
+    ])
+  ])
+
+  m4_popdef([prefix])
+  m4_popdef([module_name])
+])
